function Create(self)
	self.frames = 10	-- Number of frames - 1
	self.factor = FrameMan.PPM * TimerMan.DeltaTimeSecs --* 0.6
	self.LifeTimer = 0
	self.LastVel = Vector(self.Vel.X, self.Vel.Y)
	self.LastPos = Vector(self.Pos.X, self.Pos.Y)
	self.LastRotAngle = self.RotAngle
	
	self.HitPos = Vector()
	self.FreePos = Vector()
end

function Destroy(self)
end

function Update(self)
	self.LifeTimer = self.LifeTimer + 1
	if self.LifeTimer < 50 then	-- ~0.7s
		local Dist = self.Vel * self.factor
		local range = SceneMan:CastObstacleRay(self.Pos, Dist, self.HitPos, self.FreePos, self.ID, self.IgnoresWhichTeam, -1, 2)
		if range > -1 then
			local MO = SceneMan:CastMORay(self.FreePos, Dist, 0, self.IgnoresWhichTeam, 0, false, 0)
			if MO < 255 then
				local Pa = CreateAEmitter("Heavy Nailer Round Stick", "EDV.rte")
				Pa.Sharpness = MO
				Pa.RotAngle = self.LastRotAngle
				
				if self.HitPos.Magnitude > 1 then
					Pa.Pos = self.HitPos + Dist:CapMagnitude(3)
				else
					Pa.Pos = self.FreePos + Dist:CapMagnitude(4)
				end
				
				MovableMan:AddParticle(Pa)
				
				-- Spawn 2-4 damage particles
				for i = 1, SelectRand(2,5) do
					Pa = CreateMOPixel("Nailer Damage", "EDV.rte")
					Pa.Pos = self.FreePos
					Pa.Vel = self.LastVel
					Pa.Frame = self.Frame
					MovableMan:AddParticle(Pa)
				end
				
				self.ToDelete = true
				return
			end
	--	else
	--		print("Out of range: " .. math.floor(range))
		end
		
		self.LastVel:SetXY(self.Vel.X, self.Vel.Y)
		self.LastPos:SetXY(self.Pos.X, self.Pos.Y)
		self.LastRotAngle = self.RotAngle
	else
		self.test = not self.test	-- Test every second update
		if self.test then
			if self.Frame < self.frames then
				if self.LifeTimer > self.Frame * 20 + 20 then
					self:SetNextFrame()
				elseif PosRand() < 0.05 then
					local Smoke = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
					Smoke.Pos = self.Pos
					Smoke.Vel = self.Vel + Vector(RangeRand(-1,1), RangeRand(-2,-1))
					MovableMan:AddParticle(Smoke)
				end
			elseif self.Vel.Magnitude < 0.1 then
				self.ToSettle = true
			end
		elseif math.abs(self.Vel.X) > 40 then	-- Fake air resistance
			self.Vel.X = self.Vel.X * 0.987
		end
	end
end
