function Create(self)
	--print("Sharpness " .. self.Sharpness)
	if self.Sharpness < 255 then
		self.Target = MovableMan:GetMOFromID(self.Sharpness)
		self.LifeTimer = self.Frame * 20
		self.Sharpness = 1
		self.frames = 10	-- Number of frames - 1
		self.currFrame = self.Frame
		
		if self.Target then
			-- Only attach to attachables and bodies
			if self.Target:IsActor() then	-- Actor
				self.Target = ToActor(self.Target)
				self.Valid = function(MO) return MovableMan:IsActor(MO) end
				
	--			print("Target Actor")
			elseif self.Target:IsDevice() then	-- Weapon etc
				if self.Target.Mass / RangeRand(1,40) < 1 then
					ToMOSRotating(self.Target):GibThis()
				end
				self.Target = nil
				
	--			print("Target Device")
			elseif self.Target.ID ~= self.Target.RootID then
				self.Target = ToAttachable(self.Target)
				if self.Target.AtomSubgroupID > 0 then	-- Attachable, engine etc
					self.Parent = ToActor(MovableMan:GetMOFromID(self.Target.RootID))
					self.Valid = function(MO) return MO:IsAttached() end
					
	--				print("Target Attachable")
				else	-- Limb or Weapon etc
					if self.Target.Mass / RangeRand(1,40) < 1 then
						ToMOSRotating(self.Target):GibThis()
					end
					self.Target = nil
					
	--				print("Target Limb or Weapon etc")
				end
			else
				self.Target = nil
	--			print("Target ???")
			end
			
			if self.Target then
				-- Only attach when inside the target bounding box
				-- use SceneMan:GetMOIDPixel instead?
				
				--if ToMOSRotating(self.Target):IsOnScenePoint(self.Pos) then
				
				if self.Target.BoundingBox:WithinBox(self.Pos) then
					self.Offset = SceneMan:ShortestDistance(self.Target.Pos, self.Pos, false)
					self.Offset = self.Target:UnRotateOffset(self.Offset)
					self.RotOffset = self.Target.RotAngle - self.RotAngle
					self.Flipp = self.Target.HFlipped
					
	--				print("Hit " .. self.Target.PresetName .. ": " .. self.Target.ClassName)
				else
					self.Target = nil
	--				print("Outside BB")
				end
			else
	--			print("No target found")
			end
		end
	end
end

function Destroy(self)
end

function Update(self)
	if self.Target and self.Valid(self.Target) then
		self.Vel = Vector(0,0)
		self.Pos = self.Target.Pos + self.Target:RotateOffset(self.Offset)
		
		-- Rotate the nail
		if self.Flipp then
			if self.Target.HFlipped then
				self.RotAngle = self.Target.RotAngle + self.RotOffset
			else
				self.RotAngle = self.Target.RotAngle + 3.14 - self.RotOffset
			end
		else
			if self.Target.HFlipped then
				self.RotAngle = self.Target.RotAngle + 3.14 - self.RotOffset
			else
				self.RotAngle = self.Target.RotAngle + self.RotOffset
			end
		end
		
		self.Frame = self.currFrame
		if self.currFrame < self.frames then
			self.LifeTimer = self.LifeTimer + 1
			if self.LifeTimer > self.Frame * 20 + 20 then	-- Animate
				self.currFrame = self.currFrame + 1
			end
			
			-- Spawn smoke
			if PosRand() < 0.1 then
				local Parent
				if self.Type == 1 then
					if MovableMan:IsActor(self.Parent) then
						Parent = self.Parent
					end
				else
					Parent = self.Target
				end
				
				if Parent then
					local Smoke = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
					Smoke.Pos = self.Pos
					Smoke.Vel = self.Target.Vel + Vector(RangeRand(-1,1), RangeRand(-2,-1))
					MovableMan:AddParticle(Smoke)
				end
			end
		end
	else	-- Create a nail that can settle
		self.ToDelete = true
		local Pa = CreateMOSRotating("Heavy Nailer Round Inert", "EDV.rte")
		Pa.Pos = self.Pos
		Pa.Vel = self.Vel + Vector(RangeRand(-5,5),RangeRand(-5,5))
		self.AngularVel = self.AngularVel + RangeRand(-5,5)
		Pa.RotAngle = self.RotAngle + RangeRand(-0.2,0.2)
		Pa.Frame = self.Frame
		MovableMan:AddParticle(Pa)
	end
end