
function ArmorAssault:StartActivity()
	collectgarbage("collect")
	
	self.SpawnTimer = Timer()
	self.KeyTimer = Timer()
	self.SAMTimer = Timer()
	self.spawnDelay = RangeRand(5000, 10000)
	self.SAMs = {}
	self.timing = 100
	self.LZ1 = SceneMan.Scene:GetArea("LZ1")
	self.LZ2 = SceneMan.Scene:GetArea("LZ2")
	self.LZ3 = SceneMan.Scene:GetArea("LZ3")
	self.start = true
	self.brige = true
	
	self:SetTeamFunds(0, Activity.TEAM_1)
	
	-- Add enemy brain bot
	self.EnemyBrain = RandomAHuman("Brains", "Imperatus.rte")
	if self.EnemyBrain then
		self.EnemyBrain.Team = Activity.TEAM_2
		self.EnemyBrain.AIMode = Actor.AIMODE_SENTRY
		self.EnemyBrain:AddInventoryItem(RandomHDFirearm("Primary Weapons"))
		self.EnemyBrain:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
		MovableMan:AddActor(self.EnemyBrain)
	end
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.funds = 20000
		self.NextDelay = {min=100, max=120}
		self.EnemyBrain.Pos = SceneMan.Scene:GetArea("Brain1"):GetCenterPoint()
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.funds = 10000
		self.NextDelay = {min=80, max=100}
		self.EnemyBrain.Pos = SceneMan.Scene:GetArea("Brain1"):GetCenterPoint()
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.funds = 5000
		self.NextDelay = {min=50, max=70}
		self.EnemyBrain.Pos = SceneMan.Scene:GetArea("Brain2"):GetCenterPoint()
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.funds = 1500
		self.NextDelay = {min=60, max=80}
		self.EnemyBrain.Pos = SceneMan.Scene:GetArea("Brain2"):GetCenterPoint()
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.funds = 750
		self.NextDelay = {min=30, max=60}
		self.EnemyBrain.Pos = SceneMan.Scene:GetArea("Brain2"):GetCenterPoint()
	else
		self.funds = 250
		self.NextDelay = {min=15, max=30}
		self.EnemyBrain.Pos = SceneMan.Scene:GetArea("Brain2"):GetCenterPoint()
	end
	
	-- Player brains
	local Ship, Brain
	local players = 0
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self:PlayerActive(player) and self:PlayerHuman(player) then
			players = players + 1
			
			Brain = CreateActor("Brain Case", "Base.rte")
			Brain.Team = Activity.TEAM_1
			Brain.Pos = Vector(-40 + player * 16, 1580)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, player)
			self:SetObservationTarget(Brain.Pos, player)
			self.activePlayer = player
			
			-- Spawn player ship
			Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
			if Ship then
				Ship:AddInventoryItem(self:CreateAlliedActor())
				Ship:AddInventoryItem(self:CreateAlliedActor())
				Ship.Team = Brain.Team
				Ship.Vel = Vector(0, 18 - player*2)
				Ship.Pos = Vector(180 + player*180, -90 + player*10)
				MovableMan:AddActor(Ship)
				self:SwitchToActor(Ship, player, Ship.Team)
			end
		end
	end
	
	-- Spawn player ship 2
	if players == 1 then
		players = self.activePlayer + 1
		Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
		if Ship then
			Ship:AddInventoryItem(self:CreateAlliedActor())
			Ship:AddInventoryItem(self:CreateAlliedActor())
			Ship.Team = Activity.TEAM_1
			Ship.Vel = Vector(0, 18 - players*2)
			Ship.Pos = Vector(180 + players*180, -90 + players*10)
			MovableMan:AddActor(Ship)
		end
	end
	
	-- Guards
	local Ar
	for i = 1, 11 do
		Ar = SceneMan.Scene:GetArea("GL" .. i)
		if Ar then
			Act = self:CreateEnemyActor(0.2)
			Act.Pos = Ar:GetCenterPoint()
			Act.AIMode = Actor.AIMODE_SENTRY
			Act.HFlipped = true
			MovableMan:AddActor(Act)
		end
	end
	
	for i = 1, 4 do
		Ar = SceneMan.Scene:GetArea("GR" .. i)
		if Ar then
			Act = self:CreateEnemyActor()
			Act.Pos = Ar:GetCenterPoint()
			Act.AIMode = Actor.AIMODE_SENTRY
			Act.HFlipped = false
			MovableMan:AddActor(Act)
		end
	end
	
	for i = 1, 2 do
		Ar = SceneMan.Scene:GetArea("RPG" .. i)
		if Ar then
			Act = self:CreateEnemyActor(1.0)
			Act.Pos = Ar:GetCenterPoint()
			Act.AIMode = Actor.AIMODE_SENTRY
			Act.HFlipped = true
			MovableMan:AddActor(Act)
		end
	end
end

function ArmorAssault:CreateEnemyActor(rpg)
	rpg = rpg or 0
	
	local Act
	if PosRand() > rpg then
		Act = RandomAHuman("Heavy Infantry", "Imperatus.rte")
		if Act then
			Act:AddInventoryItem(RandomHDFirearm("Primary Weapons"))
			if PosRand() > 0.5 then
				Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
				if PosRand() > 0.5 then
					Act:AddInventoryItem(CreateHeldDevice("Riot Shield", "Base.rte"))
				end
			end
		end
	else
		Act = RandomAHuman("Heavy Infantry", "Imperatus.rte")
		if Act then
			Act:AddInventoryItem(CreateHDFirearm("Recoilless Rifle", "EDV.rte"))
			Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
		end
	end
	
	Act.Team = Activity.TEAM_2
	Act.AIMode = Actor.AIMODE_PATROL
	return Act
end

function ArmorAssault:CreateAlliedActor()
	Act = CreateAHuman("Dummy", "Dummy.rte")
	Act.Team = Activity.TEAM_1
	Act.AIMode = Actor.AIMODE_SENTRY
	Act:AddInventoryItem(RandomHDFirearm("Primary Weapons", "Dummy.rte"))
	return Act
end

function ArmorAssault:UpdateActivity()
	if not MovableMan:IsActor(self.EnemyBrain) and self.WinnerTeam ~= Activity.TEAM_1 then
		self.WinnerTeam = Activity.TEAM_1
		ActivityMan:EndActivity()
	end

	if self.SAMTimer:IsPastSimMS(self.timing) then
		self.SAMTimer:Reset()
		
		local canLaunch = true
		if self.start then
			self.crates = true -- ok to drop crates
			
			-- Find SAM sites
			for Act in MovableMan.Actors do
				if Act.PresetName == "Large SAM Site" then
					table.insert(self.SAMs, Act)
				elseif Act.PresetName == "Laser Defence" then
					self.LD = Act
				end
			end
			
			self.timing = 2500/(#self.SAMs+1)
			self.SAMindex = 1
		else		
			local RemoveList = {}
			for i = 1, #self.SAMs do
				if not MovableMan:ValidMO(self.SAMs[i]) then
					table.insert(RemoveList, i)
				end
			end
			
			for i = 1, #RemoveList do
				table.remove(self.SAMs, i)
			end
			
			if #self.SAMs > 0 then
				self.SAMindex = self.SAMindex + 1
				if self.SAMindex > #self.SAMs then
					self.SAMindex = 1
				end
			else
				canLaunch = false
				if self.crates then
					self.crates = false
				end
			end
			
			if not MovableMan:ValidMO(self.LD) then
				self.LD = nil
			end
		end
		
		local allies = 0
		if self.brige or canLaunch or self.LD then
			for Act in MovableMan.Actors do
				if Act.Team ~= Activity.TEAM_2 then
					if not Act:IsDead() then
						allies = allies + 1
					end
					
					if canLaunch and SceneMan.Scene:WithinArea("SAM", Act.Pos) and 
						(Act.ClassName == "ACRocket" or Act.ClassName == "ACDropShip" or Act.ClassName == "ACraft")
					then
						local Emitter = CreateAEmitter("Launch Flash", "EDV.rte")
						Emitter.Pos = self.SAMs[self.SAMindex].Pos + Vector(0, -15)
						Emitter.RotAngle = 1.57
						MovableMan:AddParticle(Emitter)
						
						Emitter = CreateAEmitter("Large SAM", "EDV.rte")
						Emitter.Pos = self.SAMs[self.SAMindex].Pos + Vector(0, -30)
						Emitter.Vel = Vector(0, -30)
						Emitter.RotAngle = 1.57
						Emitter.Sharpness = Act.ID
						MovableMan:AddParticle(Emitter)
						
						canLaunch = false
					elseif self.LD and SceneMan.Scene:WithinArea("Laser", Act.Pos) and 
						(Act.ClassName == "AHuman" or Act.ClassName == "ACrab")
					then
						local orig = self.LD.Pos + Vector(-10, 0)
						
						local Emitter = CreateAEmitter("Laser Flash", "EDV.rte")
						Emitter.Pos = orig
						Emitter.RotAngle = ((Act.Pos+Act.Vel) - orig).AbsRadAngle
						MovableMan:AddParticle(Emitter)
						
						Emitter = CreateAEmitter("Laser Flash", "EDV.rte")
						Emitter.Pos = orig
						Emitter.RotAngle = ((Act.Pos+Act.Vel*3) - orig).AbsRadAngle
						MovableMan:AddParticle(Emitter)
						
						Emitter = CreateAEmitter("Laser Flash", "EDV.rte")
						Emitter.Pos = orig
						Emitter.RotAngle = ((Act.Pos+Act.Vel*6) - orig).AbsRadAngle
						MovableMan:AddParticle(Emitter)
					elseif self.brige and SceneMan.Scene:WithinArea("Bridge", Act.Pos) then
						self.brige = false
						
						local Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2380, 1000)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
						
						Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2430, 1050)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
						
						Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2480, 1100)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
						
						Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2530, 1150)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
						
						Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2580, 1200)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
						
						Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2630, 1250)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
						
						Charge = CreateMOSRotating("Demo Charge", "EDV.rte")
						Charge.Pos = Vector(2680, 1300)
						Charge.Vel = Vector(0, 5)
						MovableMan:AddParticle(Charge)
					end
				end
			end
		end
		
		if self.start then
			self.start = false -- never do this again
		elseif self.crates and allies < 2 and (self.bridge or #self.SAMs > 0) then
			self.crates = false -- never do this again
			self:SetTeamFunds(self.funds, Activity.TEAM_1)	-- spawn as usual
			local Rocket
			if self.funds < 3000 then
				Rocket = CreateACRocket("Hover Tank Drop", "EDV.rte")
			else
				Rocket = CreateACRocket("Armored Car Drop", "EDV.rte")
			end
			
			if Rocket then
				Rocket.Pos = Vector(RangeRand(100,400), -50)
				Rocket.Vel = Vector(0, 10)
				Rocket.Team = Activity.TEAM_1
				MovableMan:AddActor(Rocket)
				self:SwitchToActor(Rocket, self.activePlayer, Rocket.Team)
			end
		end
	end
	
	if self.SpawnTimer:IsPastSimMS(self.spawnDelay) and MovableMan:GetMOIDCount() < 127 then
		self.SpawnTimer:Reset()
		self.spawnDelay = RangeRand(self.NextDelay.min*1000, self.NextDelay.max*1000)
		
		local rnd = PosRand()
		local Ship
		if rnd > 0.67 then
			Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Ship then
				Ship.Pos = Vector(self.LZ1:GetCenterPoint().X, -50)
			end
		elseif rnd > 0.33 then
			Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Ship then
				Ship.Pos = Vector(self.LZ2:GetCenterPoint().X, -50)
			end
		else
			Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Ship then
				Ship.Pos = Vector(self.LZ3:GetCenterPoint().X, -50)
			end
		end
		
		if Ship then
			Ship:AddInventoryItem(self:CreateEnemyActor(0.33))
			Ship:AddInventoryItem(self:CreateEnemyActor())
			Ship.Team = Activity.TEAM_2
			Ship.Vel = Vector(0, 10)
			MovableMan:AddActor(Ship)
		end
	end
	
	-- Debug: Spawn craft, activate by pressing ABCI at the same time
	if self.KeyTimer:IsPastSimMS(400) then
		if self.debug then
			if UInputMan:KeyHeld(10) then -- J
				self.KeyTimer:Reset()
				local Crb = CreateACrab("Armored Car", "EDV.rte")
				if Crb then
					Crb.Pos = Vector(RangeRand(100,400), 1200)
					Crb.Team = Activity.TEAM_1
					Crb.AIMode = Actor.AIMODE_PATROL
					print(Crb.PresetName .. " script: " .. Crb:ReloadScripts())
					MovableMan:AddActor(Crb)
					self:SwitchToActor(Crb, Crb.Team, Crb.Team)
				end
			elseif UInputMan:KeyHeld(11) then -- K
				self.KeyTimer:Reset()
				local Rocket = CreateACRocket("Armored Car Drop", "EDV.rte")
				if Rocket then
					Rocket.Pos = Vector(RangeRand(100,400), -50)
					Rocket.Team = Activity.TEAM_1
					print(Rocket.PresetName .. " script: " .. Rocket:ReloadScripts())
					MovableMan:AddActor(Rocket)
					self:SwitchToActor(Rocket, Rocket.Team, Rocket.Team)
				end
			elseif UInputMan:KeyHeld(12) then -- L
				self.KeyTimer:Reset()
				local Rocket = CreateACDropShip("Dummy Gunship", "EDV.rte")
				if Rocket then
					Rocket.Pos = Vector(800, 800)
					Rocket.Team = Activity.TEAM_1
					print(Rocket.PresetName .. " script: " .. Rocket:ReloadScripts())
					MovableMan:AddActor(Rocket)
				end
				
				local rocket = CreateAEmitter("Large SAM", "EDV.rte")
				if rocket then
					rocket.Pos = Vector(5999, 10)
					rocket.Vel = Vector(50,0)
					rocket.Sharpness = 255
					print(rocket.PresetName .. " script: " .. rocket:ReloadScripts())
					MovableMan:AddParticle(rocket)
				end
			elseif UInputMan:KeyHeld(13) then -- M
				self.KeyTimer:Reset()
				local Act = self:CreateEnemyActor()
				Act.Team = Activity.TEAM_1
				Act.Pos = Vector(RangeRand(50,450), 1200)			
				MovableMan:AddActor(Act)
			elseif UInputMan:KeyHeld(22) then
				self.KeyTimer:Reset()
				self:SetViewState(Activity.ACTORSELECT, Activity.TEAM_1)
				self:SetActorSelectCursor(Vector(1800, 900), Activity.TEAM_1)
			elseif UInputMan:KeyHeld(3) and UInputMan:KeyHeld(24) and UInputMan:KeyHeld(26) then
				self.KeyTimer:Reset()
				for Act in MovableMan.Actors do
					if Act.PresetName ~= "Brain Case" then
						Act.ToDelete = true
					end
				end
			end
		elseif UInputMan:KeyHeld(1) and UInputMan:KeyHeld(2) and UInputMan:KeyHeld(3) and UInputMan:KeyHeld(9) then
			self.KeyTimer:Reset()
			self.debug = not self.debug
			if self.debug then
				print("Debug mode on")
			else
				print("Debug mode off")
			end
		end
	end
end
