
function Overrun:StartActivity()
	collectgarbage("collect")
	
	self.SpawnTimer = Timer()
	self.KeyTimer = Timer()
	self.MissileTimer = Timer()
	self.spawnDelay = 50
	self.timingSAM = 5000
	
	self.RemoveArea = SceneMan.Scene:GetArea("Remove")
	self.SAMArea = SceneMan.Scene:GetArea("AA")
	self.LZ = {SceneMan.Scene:GetArea("LZ1"),
						SceneMan.Scene:GetArea("Rauk"),
						SceneMan.Scene:GetArea("LZ1"),
						SceneMan.Scene:GetArea("Rauk"),
						SceneMan.Scene:GetArea("LZ2"),
						SceneMan.Scene:GetArea("LZ3"),
						SceneMan.Scene:GetArea("LZ4")}
	
	self.text = 0
	self.phase = 0
	self.sniper = true
	self.spawnLeft = true	-- dropships keep to the left to avoid collisions
	self.debug = false
	self.reinforce = true
	self.destroyMsg = true
	
	self:SetTeamFunds(0, Activity.TEAM_2)
	
	self.Enemy = {}
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.PhaseGold = {500, 200, 500, 4000, 500, 2000, 500}
		self:SetTeamFunds(500, Activity.TEAM_2)
		self.Enemy.AC = "Hover Tank"
		self.Enemy.Drop = "Hover Tank Drop"
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.PhaseGold = {600, 200, 700, 6000, 500, 2800, 700}
		self:SetTeamFunds(250, Activity.TEAM_2)
		self.Enemy.AC = "Armored Car"
		self.Enemy.Drop = "Armored Car Drop"
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.PhaseGold = {600, 200, 800, 7000, 500, 3200, 800}
		self.Enemy.AC = "Armored Car"
		self.Enemy.Drop = "Armored Car Drop"
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.PhaseGold = {600, 200, 900, 8000, 500, 3800, 900}
		self.Enemy.AC = "Armored Car"
		self.Enemy.Drop = "Armored Car Drop"
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.PhaseGold = {600, 200, 1000, 10000, 500, 4000, 1000}
		self.Enemy.AC = "Armored Car"
		self.Enemy.Drop = "Armored Car Drop"
	else
		self.PhaseGold = {600, 200, 2000, 15000, 500, 6000, 1500}
		self.Enemy.AC = "Armored Car"
		self.Enemy.Drop = "Armored Car Drop"
	end
	
	-- Player brains
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self:PlayerActive(player) and self:PlayerHuman(player) then
			local Brain = CreateActor("Brain Case", "Base.rte")
			Brain.Team = Activity.TEAM_2
			Brain.Pos = Vector(4228 + player * 16, 550)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, player)
			self:SetObservationTarget(Brain.Pos, player)
			self.activePlayer = player
		end
	end
	
	-- Guards
	local Act
	local Ar = SceneMan.Scene:GetArea("GL1")
	if Ar then
		Act = self:CreatePlayer(Actor.AIMODE_SENTRY, true)
		if Act then
			Act.Pos = Ar:GetCenterPoint()
			MovableMan:AddActor(Act)
		end
	end
	
	Ar = SceneMan.Scene:GetArea("Sniper")
	if Ar then
		Act = RandomAHuman("All", "Ronin.rte")
		Act.Pos = Ar:GetCenterPoint()
		Act.Team = Activity.TEAM_2
		Act.AIMode = Actor.AIMODE_SENTRY
		Act:AddInventoryItem(CreateHDFirearm("Kar98", "Ronin.rte"))
		Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Ronin.rte"))
		MovableMan:AddActor(Act)
	end
	
	for i = 2, 4 do
		Ar = SceneMan.Scene:GetArea("GL" .. i)
		if Ar then
			Act = self:CreatePlayer(Actor.AIMODE_SENTRY, true)
			Act.Pos = Ar:GetCenterPoint()
			MovableMan:AddActor(Act)
		end
	end
	
	-- View the SAM site
	self:SetViewState(Activity.ACTORSELECT, Activity.TEAM_2)
	self:SetActorSelectCursor(Vector(2170, 740), Activity.TEAM_2)	
	
	self.Rocket = CreateACRocket("Rocklet", "Dummy.rte")
	if self.Rocket then
		self.Rocket.Pos = Vector(SceneMan.Scene:GetArea("Rauk"):GetCenterPoint().X + 500, -50)
		self.Rocket.Vel = Vector(0, 2)
		self.Rocket.Team = Activity.TEAM_1
		self.Rocket:AddInventoryItem(self:CreateEnemy())
		MovableMan:AddActor(self.Rocket)
	end
end

function Overrun:CreatePlayer(Mode, right)
	local Act = RandomAHuman("All", "Ronin.rte")
	Act.Team = Activity.TEAM_2
	Act.HFlipped = right or false
	Act.AIMode = Mode or Actor.AIMODE_SENTRY
	Act:AddInventoryItem(RandomHDFirearm("Primary Weapons", "Ronin.rte"))
	Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Ronin.rte"))
	
	if PosRand() < 0.5 then
		Act:AddInventoryItem(RandomTDExplosive("Grenades", "Ronin.rte"))
	end
	
	return Act
end

function Overrun:CreateEnemy(Mode, fly)
	local Act
	if false and fly then	-- TODO: fix the flying dummy
		Act = CreateAHuman("Flying Dummy", "EDV.rte")
		Act:AddInventoryItem(RandomHDFirearm("Light Weapons", "Dummy.rte"))
		Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Dummy.rte"))
	else
		Act = CreateAHuman("Dummy", "Dummy.rte")
		Act:AddInventoryItem(RandomHDFirearm("Primary Weapons", "Dummy.rte"))
		Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Dummy.rte"))
	end
	
	if PosRand() < 0.5 then
		Act:AddInventoryItem(RandomTDExplosive("Grenades", "Dummy.rte"))
	end
	
	Act.Team = Activity.TEAM_1
	Act.AIMode = Mode or Actor.AIMODE_BRAINHUNT
	
	return Act
end

function Overrun:UpdateActivity()
	if self.ActivityState == Activity.OVER then
		return
	end
	
	self:ClearObjectivePoints()
	
	if self.TrackingPoint then
		self.TrackingPoint = nil
		for Pt in MovableMan.Particles do
			if Pt.PresetName == "Large SAM" then
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					self:SetViewState(Activity.ACTORSELECT, player)
					self:SetActorSelectCursor(Pt.Pos, player)
				end
				
				self.TrackingPoint = true
				break
			end
		end
	end
	
	if not self.SAMSite then
		for Act in MovableMan.Actors do
			if Act.Team == Activity.TEAM_2 and Act.PresetName == "Large SAM Site" then
				self.SAMSite = Act
				break
			end
		end
	end
	
	if self.SpawnTimer:IsPastSimMS(self.spawnDelay) and MovableMan:GetMOIDCount() < 135 then
		self.SpawnTimer:Reset()
		
		if self.Rocket then
			for Act in MovableMan.Actors do
				if Act.Team == Activity.TEAM_1 and Act.ClassName == "ACRocket" then
					local Emitter = CreateAEmitter("Launch Flash", "EDV.rte")
					if Emitter then
						Emitter.Pos = Vector(2170, 720)
						Emitter.RotAngle = 1.57
						Emitter.Team = Activity.TEAM_2
						MovableMan:AddParticle(Emitter)
						
						Emitter = CreateAEmitter("Large SAM", "EDV.rte")
						if Emitter then
							Emitter.Pos = Vector(2170, 700)
							Emitter.Vel = Vector(0, -10)
							Emitter.RotAngle = 1.57
							Emitter.Sharpness = Act.ID
							Emitter.Team = Activity.TEAM_2
							MovableMan:AddParticle(Emitter)
							self.TrackingPoint = true
						end
					end
					
					break
				end
			end
			
			self.SpawnTimer:Reset()
			self.spawnDelay = 3300
			self.Rocket = nil
		else
			if self.phase == 0 then	-- Select the clone at the rauk
				self.phase = 1
				self:SetTeamFunds(self.PhaseGold[self.phase], Activity.TEAM_1)
				self.spawnDelay = 300
				
				for Act in MovableMan.Actors do
					if SceneMan.Scene:WithinArea("Rauk", Act.Pos) then
						if Act.Team == Activity.TEAM_2 then -- The player has a clone at the rauk
							self:SwitchToActor(Act, self.activePlayer, Act.Team)
							break
						end
					end
				end
			elseif self.phase == 1 then				
				if self:GetTeamFunds(Activity.TEAM_1) > 0 then	-- Land some cannon fodder
					self.spawnDelay = RangeRand(8000, 12000)
					local Ship = RandomACDropShip("All", "Dummy.rte")
					if Ship then
						local Act = self:CreateEnemy(Actor.AIMODE_GOTO)
						Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("LZ2"):GetCenterPoint())
						Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("GL" .. SelectRand(2, 5)):GetCenterPoint())
						Ship:AddInventoryItem(Act)
						
						if PosRand() < 0.6 then
							Act = self:CreateEnemy(Actor.AIMODE_GOTO, true)
							Act:AddAISceneWaypoint(Vector(1777, 565))	-- the outpost's tower
							local OnRauk = SceneMan:MovePointToGround(Vector(SceneMan.Scene:GetArea("Rauk"):GetCenterPoint().X+RangeRand(250, 350), 0), 25, 4)
							Act:AddAISceneWaypoint(OnRauk)	-- behind the rauk
						else
							Act = self:CreateEnemy(Actor.AIMODE_GOTO)
							Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("LZ2"):GetCenterPoint())
							Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("GL" .. SelectRand(2, 5)):GetCenterPoint())
						end
						
						Ship:AddInventoryItem(Act)
						
						Ship.Team = Activity.TEAM_1
						Ship.Vel = Vector(0, 10)
						
						if self.spawnLeft then
							Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(-50, 50), -50)
						else
							Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(100, 200), -50)
						end
						
						self.spawnLeft = not self.spawnLeft
						
						self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
						MovableMan:AddActor(Ship)
					end
				else
					self.phase = 3
					self.spawnDelay = 500
					for Act in MovableMan.Actors do
						if SceneMan.Scene:WithinArea("Rauk", Act.Pos) then
							if Act.Team == Activity.TEAM_2 then -- The player has a clone at the rauk
								self.phase = 2
							else	 -- The AI has a clone at the rauk
								self.phase = 3
								break
							end
						end
					end
					
					if self.phase == 2 then
						self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase], Activity.TEAM_1)
					else
						self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase] + self.PhaseGold[2], Activity.TEAM_1)
					end
				end
			elseif self.phase == 2 then	-- Bomb the rauk
				self.spawnDelay = RangeRand(11000, 15000)
				local Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
				if Ship then
					for i = 1, RangeRand(4, 7) do
						Ship:AddInventoryItem(CreateMOSRotating("Disruptor Cluster Bomb", "EDV.rte"))
					end
					
					Ship.Team = Activity.TEAM_1
					Ship.Vel = Vector(0, 16)
					Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(-60, -10), -40)
					MovableMan:AddActor(Ship)				
				end
				
				self.phase = 3
				self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase], Activity.TEAM_1)
			elseif self.phase == 3 then
				if not MovableMan:IsActor(self.SAMSite) then	-- the SAM site is gone
					self.phase = 5
					self.spawnDelay = 500
					self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase-1] + self.PhaseGold[self.phase], Activity.TEAM_1)
				elseif self:GetTeamFunds(Activity.TEAM_1) > 0 then	-- Land some more cannon fodder, but this time with armed drop ships
					local Ship = nil
					if self.sniper then
						self.sniper = false
						self.spawnDelay = RangeRand(6000, 9000)
						Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
						if Ship then
							local Act = CreateAHuman("Dummy", "Dummy.rte")
							Act.Team = Activity.TEAM_1
							Act.AIMode = Actor.AIMODE_SENTRY
							
							local Weapon = CreateHDFirearm("Scouting Rifle", "Dummy.rte")
							if Weapon then
								Act:AddInventoryItem(Weapon)
							else
								Act:AddInventoryItem(CreateHDFirearm("Flak Cannon", "Base.rte"))
							end
							
							Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Dummy.rte"))
							
							Ship:AddInventoryItem(Act)
							Ship.Team = Activity.TEAM_1
							Ship.Vel = Vector(0, 10)
							Ship.Pos = Vector(SceneMan.Scene:GetArea("GL1"):GetCenterPoint().X, -50)	-- on top of the rauk
							self.spawnLeft = true
							
							self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
							MovableMan:AddActor(Ship)
						end
					else
						self.spawnDelay = RangeRand(8000, 14000)
						Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
						if Ship then
							local Act
							if PosRand() < 0.5 then
								Act = self:CreateEnemy(Actor.AIMODE_GOTO, true)
								Act:AddAISceneWaypoint(Vector(1777, 565))	-- the outpost's tower
								Ship:AddInventoryItem(Act)
							elseif MovableMan:IsActor(self.SAMSite) then
								Act = self:CreateEnemy(Actor.AIMODE_GOTO, PosRand() < 0.5)
								Act:AddAIMOWaypoint(self.SAMSite)
								Ship:AddInventoryItem(Act)
							end
							
							Act = self:CreateEnemy(Actor.AIMODE_GOTO)
							Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("LZ2"):GetCenterPoint())
							Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("GL" .. SelectRand(2, 5)):GetCenterPoint())
							Ship:AddInventoryItem(Act)
							
							Ship.Team = Activity.TEAM_1
							Ship.Vel = Vector(0, 10)
							
							if self.spawnLeft then
								Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(0, 100), -50)
							else
								Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(200, 300), -50)
							end
							
							self.spawnLeft = not self.spawnLeft
							
							self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
							MovableMan:AddActor(Ship)
						end
					end
				else
					self.spawnDelay = RangeRand(10000, 20000)
					self.phase = 4
					self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase], Activity.TEAM_1)
				end
			elseif self.phase == 4 then -- Deploy some armored cars
				if not MovableMan:IsActor(self.SAMSite) then	-- the SAM site is gone
					self.phase = 5
					self.spawnDelay = 1000
					self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase], Activity.TEAM_1)
				elseif self:GetTeamFunds(Activity.TEAM_1) > 0 then
					self.spawnDelay = RangeRand(7000, 11000)
					local Armor = false
					for Act in MovableMan.Actors do	-- Check if the AI has any armored cars
						if Act.Team == Activity.TEAM_1 and (Act.PresetName == self.Enemy.AC or Act.PresetName == self.Enemy.Drop) then
							Armor = true
							local Pt = SceneMan.Scene:GetArea("Mortar"):GetCenterPoint() + Vector(RangeRand(200, 370), 0)
							Act:AddAISceneWaypoint(SceneMan:MovePointToGround(Pt, 30, 1))
							Act.AIMode = Actor.AIMODE_GOTO
							break
						end
					end
					
					-- only land armor if the outpost is occupied					
					if not Armor then
						Armor = true
						for Act in MovableMan.Actors do
							if Act.Team == Activity.TEAM_2 and SceneMan.Scene:WithinArea("Outpost", Act.Pos) then
								-- The player has a clone at the outpost
								Armor = false
								break
							end
						end
					end
					
					if not Armor then
						local Rocket = CreateACRocket(self.Enemy.Drop, "EDV.rte")
						if Rocket then
							Rocket.Team = Activity.TEAM_1
							Rocket.Vel = Vector(0, 5)
							Rocket.Pos = Vector(SceneMan.Scene:GetArea("Rauk"):GetCenterPoint().X + RangeRand(250, 400), -50)
							Rocket:AddAISceneWaypoint(Vector(1500, 778))	-- Infront of the outpost
							MovableMan:AddActor(Rocket)
							self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Rocket:GetTotalValue(0, 2), Activity.TEAM_1)
						end
						
						if self.reinforce then
							self.reinforce = false
							local Ship = RandomACDropShip("All", "Base.rte")
							if Ship then
								Ship:AddInventoryItem(self:CreatePlayer())
								
								local Act = RandomAHuman("All", "Ronin.rte")
								Act.Team = Activity.TEAM_2
								Act.AIMode = Actor.AIMODE_SENTRY
								
								if math.random() < 0.2 then
									Act:AddInventoryItem(CreateHDFirearm("Recoilless Rifle", "EDV.rte"))
								else
									Act:AddInventoryItem(CreateHDFirearm("RPG-7", "Ronin.rte"))
								end
								
								Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Ronin.rte"))
								Ship:AddInventoryItem(Act)
								
								Ship.Team = Activity.TEAM_2
								Ship.Vel = Vector(0, 10)
								Ship.Pos = Vector(SceneMan.Scene:GetArea("LZ2"):GetCenterPoint().X, -50)
								MovableMan:AddActor(Ship)
								self.Marker = Ship
							end
						end
					else					
						local Ship = RandomACDropShip("All", "Dummy.rte")
						if Ship then
							if PosRand() < 0.2 then
								local Act = self:CreateEnemy(Actor.AIMODE_GOTO, true)
								Act:AddAISceneWaypoint(Vector(1777, 565))	-- the outpost's tower
								Ship:AddInventoryItem(Act)
								
								Act = self:CreateEnemy(Actor.AIMODE_GOTO)
								Act:AddAISceneWaypoint(Vector(2000, 440))	-- above the SAM site
								Ship:AddInventoryItem(Act)
							elseif MovableMan:IsActor(self.SAMSite) then
								local Act = self:CreateEnemy(Actor.AIMODE_GOTO)
								Act:AddAIMOWaypoint(self.SAMSite)
								Ship:AddInventoryItem(Act)
								
								Act = self:CreateEnemy(Actor.AIMODE_GOTO)
								Act:AddAIMOWaypoint(self.SAMSite)
								Ship:AddInventoryItem(Act)
							end
							
							Ship.Team = Activity.TEAM_1
							Ship.Vel = Vector(0, 10)
							
							if self.spawnLeft then
								Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(-200, -100), -50)
							else
								Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(-30, 50), -50)
							end
							
							self.spawnLeft = not self.spawnLeft
							
							self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
							MovableMan:AddActor(Ship)
						end
					end
				else
					self.spawnDelay = 3000
					self.text = 1
					
					local enemies = false
					for Act in MovableMan.Actors do
						if Act.Team == Activity.TEAM_1 then
							enemies = true
							break
						end
					end
					
					if not enemies then
						self.WinnerTeam = Activity.TEAM_2
						ActivityMan:EndActivity()
					end
				end
			elseif self.phase == 5 then	-- prepare for the assault on the brain
				self.text = 0
				
				if SceneMan:GetOffset(Activity.TEAM_2).X > 2300 then	-- remove all enemies left of the outpost if the player can not see it
					for Act in MovableMan.Actors do
						if Act.Team == Activity.TEAM_1 and Act.ClassName ~= "ACDropShip" and self.RemoveArea:IsInside(Act.Pos) then
							Act.ToDelete = true
						end
					end
				else
					-- Move towards the next objective
					for Act in MovableMan.Actors do
						if Act.Team == Activity.TEAM_1 and Act.ClassName == "AHuman" then
							Act.AIMode = Actor.AIMODE_BRAINHUNT
						end
					end
				end
				
				local Ar = SceneMan.Scene:GetArea("GR1")
				if Ar then
					Act = self:CreatePlayer(Actor.AIMODE_SENTRY, true)
					Act.Pos = Ar:GetCenterPoint()
					MovableMan:AddActor(Act)
				end
				
				for i = 5, 7 do
					Ar = SceneMan.Scene:GetArea("GL" .. i)
					if Ar then
						Act = self:CreatePlayer()
						Act.Pos = Ar:GetCenterPoint()
						MovableMan:AddActor(Act)
					end
				end
				
				local Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
				if Ship then
					Ship:AddInventoryItem(self:CreateEnemy(Actor.AIMODE_BRAINHUNT))
					Ship:AddInventoryItem(self:CreateEnemy(Actor.AIMODE_BRAINHUNT))
					
					Ship.Team = Activity.TEAM_1
					Ship.Vel = Vector(0, 10)
					
					if self.spawnLeft then
						Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(0, 50), -50)
					else
						Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(150, 300), -50)
					end
					
					self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
					MovableMan:AddActor(Ship)				
				end
				
				if self.Difficulty > GameActivity.EASYDIFFICULTY then
					-- spawn a gunship
					Ship = CreateACDropShip("Dummy Gunship", "EDV.rte")
					if Ship then
						Ship.Team = Activity.TEAM_1
						Ship.Vel = Vector(10, -5)
						Ship.Pos = Vector(self.LZ[2]:GetCenterPoint().X, -50)	-- rauk
						Ship:AddAISceneWaypoint(SceneMan.Scene:GetArea("GL4"):GetCenterPoint()+Vector(0,-150))
						
						self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
						MovableMan:AddActor(Ship)				
					end
				end
				
				-- give the player some reinforcements
				Ship = RandomACDropShip("All", "Base.rte")
				if Ship then
					Ship:AddInventoryItem(self:CreatePlayer())
					Ship:AddInventoryItem(self:CreatePlayer())
					Ship.Team = Activity.TEAM_2
					Ship.Vel = Vector(0, 5)
					Ship.Pos = Vector(SceneMan.Scene:GetArea("LZ4"):GetCenterPoint().X, -50)
					MovableMan:AddActor(Ship)
					self.Marker = Ship
				end
				
				self.spawnDelay = 2000
				self.phase = 6
				self.spawnLeft = true
				self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) + self.PhaseGold[self.phase], Activity.TEAM_1)
			elseif self.phase == 6 then
				self.text = 0
				self.spawnDelay = RangeRand(6000, 10000)
				for Act in MovableMan.Actors do	-- Check if the AI has any armored cars
					if Act.Team == Activity.TEAM_1 and Act.PresetName == self.Enemy.AC then
						Act:AddAISceneWaypoint(SceneMan.Scene:GetArea("LZ3"):GetCenterPoint())
						Act.AIMode = Actor.AIMODE_GOTO
					end
				end
				
				if self:GetTeamFunds(Activity.TEAM_1) > 0 then
					local Ship = nil
					if PosRand() < 0.6 then
						Ship = RandomACDropShip("All", "Dummy.rte")
					else
						Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
					end
					
					if Ship then
						Ship:AddInventoryItem(self:CreateEnemy(Actor.AIMODE_BRAINHUNT))
						Ship:AddInventoryItem(self:CreateEnemy(Actor.AIMODE_BRAINHUNT))
						
						Ship.Team = Activity.TEAM_1
						Ship.Vel = Vector(0, 10)
						
						if self.spawnLeft then
							Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(-400, -200), -50)
						else
							if PosRand() < 0.5 then
								Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X + RangeRand(250, 350), -50)
							else
								Ship.Pos = Vector(self.LZ[self.phase+1]:GetCenterPoint().X + RangeRand(-100, 0), -50)
							end
						end
						
						self.spawnLeft = not self.spawnLeft
						
						self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
						MovableMan:AddActor(Ship)
					end
				else
					-- almost out of gold: try landing some troops on the roof
					self.phase = 7
				end
			elseif self.phase == 7 then
				self.text = 0
				local Ship = CreateACDropShip("Armed Dropship", "EDV.rte")
				if Ship then
					Ship:AddInventoryItem(self:CreateEnemy(Actor.AIMODE_BRAINHUNT))
					Ship:AddInventoryItem(self:CreateEnemy(Actor.AIMODE_BRAINHUNT))
					
					Ship.Team = Activity.TEAM_1
					Ship.Vel = Vector(0, 5)
					Ship.Pos = Vector(self.LZ[self.phase]:GetCenterPoint().X, -50)
					
					self:SetTeamFunds(self:GetTeamFunds(Activity.TEAM_1) - Ship:GetTotalValue(0, 2), Activity.TEAM_1)
					MovableMan:AddActor(Ship)
				end
				
				self.phase = 8
				self.spawnDelay = 3000
			else
				self.text = 1
				local enemies = false
				for Act in MovableMan.Actors do
					if Act.Team == Activity.TEAM_1 then
						enemies = true
						break
					end
				end
				
				if not enemies then
					self.WinnerTeam = Activity.TEAM_2
					ActivityMan:EndActivity()
				end
			end
		end
	elseif self.phase < 4 and self.MissileTimer:IsPastSimMS(self.timingSAM) then
		self.MissileTimer:Reset()
		self.timingSAM = 1000
		
		for Act in MovableMan.Actors do
			if Act.Team == Activity.TEAM_1 and Act.ClassName == "ACDropShip" and self.SAMArea:IsInside(Act.Pos) then
				self.timingSAM = 5000
				
				local Emitter = CreateAEmitter("Launch Flash", "EDV.rte")
				Emitter.Pos = Vector(2170, 720)
				Emitter.RotAngle = 1.57
				MovableMan:AddParticle(Emitter)
				
				Emitter = CreateAEmitter("Large SAM", "EDV.rte")
				Emitter.Pos = Vector(2170, 700)
				Emitter.Vel = Vector(0, -10)
				Emitter.RotAngle = 1.57
				Emitter.Sharpness = Act.ID
				MovableMan:AddParticle(Emitter)
				break
			end
		end
	end
	
	if self.text > 0 then
		FrameMan:ClearScreenText(Activity.TEAM_2)
		FrameMan:SetScreenText("The attack has stalled, destroy all enemies.", Activity.TEAM_2, 0, 2000, false)
	end
	
	if self.Marker then
		if MovableMan:IsActor(self.Marker) and self.Marker.ClassName == "ACDropShip" then
			self:AddObjectivePoint("Reinforcements", self.Marker.AboveHUDPos, Activity.TEAM_2, GameActivity.ARROWDOWN)
		else
			self.Marker = nil
		end
	end
	
	-- Debug: Spawn craft, activate by pressing ABCI at the same time
	if self.KeyTimer:IsPastSimMS(400) then
		if self.debug then
			if UInputMan:KeyHeld(6) then	-- F-key
				self.KeyTimer:Reset()
				local Act = CreateAHuman("Flying Dummy", "EDV.rte")	-- tries to fly to any waypoint with a lower y-coordinate
				if Act then
					print(Act.PresetName .. " reload = " .. Act:ReloadScripts())
					Act:AddInventoryItem(CreateHDFirearm("AK-47", "Base.rte"))
					Act.Pos = Vector(600, 700)
					Act.Team = Activity.TEAM_2
					--Act.AIMode = Actor.AIMODE_NONE
					
					MovableMan:AddActor(Act)
					self:SwitchToActor(ToActor(Act), Act.Team, Act.Team)
				end
			elseif UInputMan:KeyHeld(10) then -- J
				self.KeyTimer:Reset()
				local Crb = CreateACrab(self.Enemy.AC, "EDV.rte")
				if Crb then
					Crb.Pos = Vector(RangeRand(100,400), 600)
					Crb.Team = Activity.TEAM_2
					Crb.AIMode = Actor.AIMODE_PATROL
					print(Crb.PresetName .. " script: " .. Crb:ReloadScripts())
					MovableMan:AddActor(Crb)
					self:SwitchToActor(ToActor(Crb), Crb.Team, Crb.Team)
				end
			elseif UInputMan:KeyHeld(11) then -- K
				self.KeyTimer:Reset()
				local Rocket = CreateACRocket(self.Enemy.Drop, "EDV.rte")
				if Rocket then
					Rocket.Pos = Vector(RangeRand(100,400), -50)
					Rocket.Team = Activity.TEAM_2
					print(Rocket.PresetName .. " script: " .. Rocket:ReloadScripts())
					MovableMan:AddActor(Rocket)
					self:SwitchToActor(ToActor(Rocket), Rocket.Team, Rocket.Team)
				end
			elseif UInputMan:KeyHeld(12) then -- L
				self.KeyTimer:Reset()
				local Rocket = CreateACDropShip("Dummy Gunship", "EDV.rte")
				if Rocket then
					Rocket.Pos = Vector(1000, 400)
					Rocket.Team = Activity.TEAM_1
					print(Rocket.PresetName .. " script: " .. Rocket:ReloadScripts())
					MovableMan:AddActor(Rocket)
			--		self:SwitchToActor(ToActor(Rocket), Rocket.Team, Rocket.Team)
				end
				
				local rocket = CreateAEmitter("Large SAM", "EDV.rte")
				if rocket then
					rocket.Pos = Vector(3000, 100)
					rocket.Vel = Vector(50,-5)
					rocket.Sharpness = 255
					print(rocket.PresetName .. " script: " .. rocket:ReloadScripts())
					MovableMan:AddParticle(rocket)
				end
			elseif UInputMan:KeyHeld(13) then -- M
				self.KeyTimer:Reset()
				local Act = self:CreateEnemy(Actor.AIMODE_BRAINHUNT)
				Act.Team = Activity.TEAM_2
				Act.Pos = Vector(RangeRand(50,450), 400)			
				MovableMan:AddActor(Act)
			elseif UInputMan:KeyHeld(28) then	-- #1
				self.KeyTimer:Reset()
				print(SceneMan:GetOffset(Activity.TEAM_2))
			elseif UInputMan:KeyHeld(22) then
				self.KeyTimer:Reset()
				self:SetViewState(Activity.ACTORSELECT, Activity.TEAM_2)
				self:SetActorSelectCursor(Vector(1800, 400), Activity.TEAM_2)
			elseif UInputMan:KeyHeld(3) and UInputMan:KeyHeld(24) and UInputMan:KeyHeld(26) then
				self.KeyTimer:Reset()
				for Act in MovableMan.Actors do
					if Act.PresetName ~= "Brain Case" then
						Act.ToDelete = true
					end
				end
			end
		elseif UInputMan:KeyHeld(1) and UInputMan:KeyHeld(2) and UInputMan:KeyHeld(3) and UInputMan:KeyHeld(9) then
			self.KeyTimer:Reset()
			self.debug = not self.debug
			if self.debug then
				print("Debug mode on")
			else
				print("Debug mode off")
			end
		end
	end
end
